name: Release of the docker image
on:
  push:
    branches:
      - main
      
  workflow_dispatch:

jobs:
  builde-image:
    environment: 'Apalia - Lab'
    name: build docker image
    runs-on: ubuntu-latest
    
    steps: 
    - name: Checkout code
      uses: actions/checkout@v2
      with:
        ref: ${{ github.head_ref }}
          
    - name: Set up QEMU
      uses: docker/setup-qemu-action@v3
        
    - name: Set up Docker Buildx
      uses: docker/setup-buildx-action@v3
    
    - name: DockerHub login
      uses:  docker/login-action@v3.2.0
      with:
        username: ${{ secrets.DOCKER_HUB_USERNAME }}
        password: ${{ secrets.DOCKER_HUB_PASSWORD }}

    - name: Build image
      run: |
        docker build --build-arg="APP_URL=fabriquepar.127.0.0.1.nip.io" -t ${{ secrets.DOCKER_HUB_USERNAME }}/craftedby-frontend:v1.0.0 .
    
    - name: Check image vulnerabilities
      uses: aquasecurity/trivy-action@0.20.0
      with:
        image-ref: '${{ secrets.DOCKER_HUB_USERNAME }}/craftedby-frontend:v1.0.0'
        format: 'sarif'
        output: 'trivy-results.sarif'

    - name: DEBUG
      run: |
        ls -a
        cat trivy-results.sarif

    - name: Upload Trivy scan results to GitHub Security tab
      uses: github/codeql-action/upload-sarif@v3
      with:
        sarif_file: 'trivy-results.sarif'
    
    - name: Run Trivy in GitHub SBOM mode and submit results to Dependency Graph
      uses: aquasecurity/trivy-action@0.20.0
      with:
        scan-type: 'fs'
        format: 'github'
        output: 'dependency-results.sbom.json'
        image-ref: '.'
        github-pat: ${{ secrets.GITHUB_TOKEN }}

    - name: Push image to DockerHub
      run: |
        docker push ${{ secrets.DOCKER_HUB_USERNAME }}/craftedby-frontend:v1.0.0

